package cn.com.qmth.examcloud.core.oe.admin.api.controller;

import cn.com.qmth.examcloud.core.oe.admin.base.utils.excel.ExportUtils;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamStatisticService;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.statistic.ExamStatisticInfo;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.statistic.OverviewInfo;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

@RestController
@Api(tags = "考试统计相关接口")
@RequestMapping("${$rmp.ctr.oe}/exam/statistic")
public class ExamStatisticController extends ControllerSupport {

    @Autowired
    private ExamStatisticService examStatisticService;

    @PostMapping("/overview")
    @ApiOperation(value = "统计概况")
    public OverviewInfo overview(@RequestParam Long examId, @RequestParam Long courseId) {
        return examStatisticService.overview(examId, courseId);
    }

    @PostMapping("/overview/for/org")
    @ApiOperation(value = "统计概况（学习中心）")
    public List<ExamStatisticInfo> overviewForOrg(@RequestParam Long examId, @RequestParam Long courseId) {
        return examStatisticService.overviewForOrg(examId, courseId);
    }

    @GetMapping("/overview/for/org/export")
    @ApiOperation(value = "统计概况（学习中心）导出Excel")
    public void overviewForOrgExport(@RequestParam Long examId, @RequestParam Long courseId
            , HttpServletResponse response) throws Exception {
        List<ExamStatisticInfo> list = examStatisticService.overviewForOrg(examId, courseId);
        ExportUtils.exportEXCEL("学习中心统计", ExamStatisticInfo.class, list, response);
    }

}
